"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importDefault(require("lodash"));
const get_class_from_fqcn_1 = __importDefault(require("../../utils/get-class-from-fqcn"));
const get_prisma_fqcn_1 = __importDefault(require("../../helpers/get-prisma-fqcn"));
const prettier_1 = require("../../utils/prettier");
const get_model_fqcn_1 = __importDefault(require("../../helpers/get-model-fqcn"));
const get_model_classname_1 = __importDefault(require("../../helpers/get-model-classname"));
const generateModel = (model, prefix = 'Prisma') => {
    const { namespace } = (0, get_model_fqcn_1.default)(model);
    const { fqcn: prismaFqcn } = (0, get_prisma_fqcn_1.default)(model, prefix);
    const imports = new Set();
    imports.add(prismaFqcn);
    return (0, prettier_1.prettify)(`<?php
    namespace ${namespace};

    ${lodash_1.default.chain([...imports])
        .map(importFcqn => `use ${importFcqn};`)
        .join('\n')
        .value()}

    /**
     * ${(0, get_model_classname_1.default)(model)} Model
     *
     * {@inheritdoc}
     */
    class ${(0, get_model_classname_1.default)(model)} extends ${(0, get_class_from_fqcn_1.default)(prismaFqcn)} {

    }
  `);
};
exports.default = generateModel;
//# sourceMappingURL=generator.js.map