"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importStar(require("lodash"));
const get_class_from_fqcn_1 = __importDefault(require("../../utils/get-class-from-fqcn"));
const composite_key_error_1 = __importDefault(require("../../errors/composite-key-error"));
const get_prisma_fqcn_1 = __importDefault(require("../../helpers/get-prisma-fqcn"));
const get_cast_and_rules_from_field_1 = __importDefault(require("../../utils/get-cast-and-rules-from-field"));
const invalid_laravel_timestamps_error_1 = __importDefault(require("../../errors/invalid-laravel-timestamps-error"));
const is_field_created_timestamp_1 = __importDefault(require("../../helpers/is-field-created-timestamp"));
const is_field_updated_timestamp_1 = __importDefault(require("../../helpers/is-field-updated-timestamp"));
const is_field_guarded_1 = __importDefault(require("../../helpers/is-field-guarded"));
const is_field_fillable_1 = __importDefault(require("../../helpers/is-field-fillable"));
const is_field_deleted_timestamp_1 = __importDefault(require("../../helpers/is-field-deleted-timestamp"));
const get_default_from_field_1 = __importDefault(require("../../utils/get-default-from-field"));
const get_phpdoc_properties_from_field_1 = __importDefault(require("../../utils/get-phpdoc-properties-from-field"));
const get_table_name_from_model_1 = __importDefault(require("../../helpers/get-table-name-from-model"));
const get_map_field_attribute_1 = __importDefault(require("../../utils/raw-schema/get-map-field-attribute"));
const mapped_field_error_1 = __importDefault(require("../../errors/mapped-field-error"));
const prettier_1 = require("../../utils/prettier");
const is_model_mass_assignable_1 = __importDefault(require("../../helpers/is-model-mass-assignable"));
const mass_assignable_conflict_error_1 = __importDefault(require("../../errors/mass-assignable-conflict-error"));
const fillable_guarded_conflict_error_1 = __importDefault(require("../../errors/fillable-guarded-conflict-error"));
const is_field_hidden_1 = __importDefault(require("../../helpers/is-field-hidden"));
const is_field_visible_1 = __importDefault(require("../../helpers/is-field-visible"));
const hidden_visible_conflict_error_1 = __importDefault(require("../../errors/hidden-visible-conflict-error"));
const is_field_relation_1 = __importDefault(require("../../helpers/is-field-relation"));
const get_relations_from_model_1 = __importDefault(require("../../utils/get-relations-from-model"));
const is_field_touching_1 = __importDefault(require("../../helpers/is-field-touching"));
const is_field_eager_loaded_1 = __importDefault(require("../../helpers/is-field-eager-loaded"));
const is_model_pivot_1 = __importDefault(require("../../helpers/is-model-pivot"));
const get_php_arguments_with_defaults_1 = __importDefault(require("../../helpers/get-php-arguments-with-defaults"));
const get_unsupported_fields_1 = __importDefault(require("../../utils/raw-schema/get-unsupported-fields"));
const get_model_classname_1 = __importDefault(require("../../helpers/get-model-classname"));
const get_model_traits_1 = __importDefault(require("../../helpers/get-model-traits"));
const get_model_extend_1 = __importDefault(require("../../helpers/get-model-extend"));
const get_model_implements_1 = __importDefault(require("../../helpers/get-model-implements"));
const generatePrismaModel = (model, models, enums, rawSchema, provider, baseModel = 'Illuminate\\Database\\Eloquent\\Model', basePivotModel = 'Illuminate\\Database\\Eloquent\\Relations\\Pivot', prefix = 'Prisma', explicitTableNamesOnRelations = true) => {
    var _a;
    const { name: className, fields: allFields, primaryKey } = model;
    const fields = [
        ...lodash_1.default.filter(allFields, f => !(0, is_field_relation_1.default)(f)),
        ...(0, get_unsupported_fields_1.default)(className, rawSchema),
    ];
    const tableName = (0, get_table_name_from_model_1.default)(model);
    const { namespace } = (0, get_prisma_fqcn_1.default)(model, prefix);
    const imports = new Set();
    imports.add('\\Illuminate\\Database\\Eloquent\\Builder');
    imports.add('\\Closure');
    const traits = new Set();
    for (const t of (0, get_model_traits_1.default)(model)) {
        imports.add(t);
        traits.add((0, get_class_from_fqcn_1.default)(t));
    }
    if (primaryKey && primaryKey.fields.length > 1) {
        throw new composite_key_error_1.default();
    }
    const primaryKeyField = lodash_1.default.find(fields, f => f.isId);
    if (primaryKeyField) {
        const mappedField = (0, get_map_field_attribute_1.default)(primaryKeyField.name, className, rawSchema);
        if (mappedField) {
            primaryKeyField.name = mappedField;
        }
    }
    if (lodash_1.default.some(fields, field => {
        const mappedName = (0, get_map_field_attribute_1.default)(field.name, className, rawSchema);
        return !field.isId && mappedName && mappedName !== field.name;
    })) {
        throw new mapped_field_error_1.default();
    }
    const isPivot = (0, is_model_pivot_1.default)(model);
    const extendsClass = (_a = (0, get_model_extend_1.default)(model)) !== null && _a !== void 0 ? _a : (isPivot ? basePivotModel : baseModel);
    const implementClasses = new Set();
    for (const implementClass of (0, get_model_implements_1.default)(model)) {
        imports.add(implementClass);
        implementClasses.add((0, get_class_from_fqcn_1.default)(implementClass));
    }
    const { imports: relationImports, hasOne, belongsTo, hasMany, belongsToMany, } = (0, get_relations_from_model_1.default)(model, models, explicitTableNamesOnRelations);
    for (const relationImport of relationImports) {
        imports.add(relationImport);
    }
    const createdAtField = lodash_1.default.find(fields, f => (0, is_field_created_timestamp_1.default)(f));
    const updatedAtField = lodash_1.default.find(fields, f => (0, is_field_updated_timestamp_1.default)(f));
    if ((createdAtField && !updatedAtField) ||
        (!createdAtField && updatedAtField)) {
        throw new invalid_laravel_timestamps_error_1.default();
    }
    const deletedAtField = lodash_1.default.find(fields, f => (0, is_field_deleted_timestamp_1.default)(f));
    if (deletedAtField) {
        imports.add('Illuminate\\Database\\Eloquent\\SoftDeletes');
        traits.add('SoftDeletes');
    }
    const massAssignable = (0, is_model_mass_assignable_1.default)(model);
    const fillableFields = lodash_1.default.filter(fields, f => (0, is_field_fillable_1.default)(f));
    const guardedFields = lodash_1.default.filter(fields, f => (0, is_field_guarded_1.default)(f));
    const touchingFields = lodash_1.default.filter(allFields, f => (0, is_field_touching_1.default)(f));
    const eagerLoadedFields = lodash_1.default.filter(allFields, f => (0, is_field_eager_loaded_1.default)(f));
    if (massAssignable &&
        (!lodash_1.default.isEmpty(fillableFields) || !lodash_1.default.isEmpty(guardedFields))) {
        throw new mass_assignable_conflict_error_1.default();
    }
    if (!lodash_1.default.isEmpty(fillableFields) && !lodash_1.default.isEmpty(guardedFields)) {
        throw new fillable_guarded_conflict_error_1.default();
    }
    const hiddenFields = lodash_1.default.filter(fields, f => (0, is_field_hidden_1.default)(f));
    const visibleFields = lodash_1.default.filter(fields, f => (0, is_field_visible_1.default)(f));
    if (!lodash_1.default.isEmpty(hiddenFields) && !lodash_1.default.isEmpty(visibleFields)) {
        throw new hidden_visible_conflict_error_1.default();
    }
    const defaults = lodash_1.default.chain(fields)
        .reduce((object, field) => {
        const result = lodash_1.default.clone(object);
        const { defaultValue: fieldDefault, isMethodCall, imports: fieldImports, } = (0, get_default_from_field_1.default)(field, enums, provider);
        result[field.name] = { value: fieldDefault, isMethodCall };
        for (const fieldImport of fieldImports) {
            imports.add(fieldImport);
        }
        return result;
    }, {})
        .omitBy(v => lodash_1.default.isNil(v.value))
        .value();
    const defaultsWithMethodCall = lodash_1.default.some(lodash_1.default.values(defaults), d => d.isMethodCall);
    let primaryKeyCast;
    if (primaryKeyField) {
        primaryKeyCast = (0, get_cast_and_rules_from_field_1.default)(primaryKeyField, model, enums, guardedFields, fillableFields, massAssignable, rawSchema, provider).cast;
    }
    const { casts, rules } = lodash_1.default.chain(fields)
        .reduce((object, field) => {
        const result = lodash_1.default.clone(object);
        const { cast: fieldCast, rules: fieldRules, imports: fieldImports, } = (0, get_cast_and_rules_from_field_1.default)(field, model, enums, guardedFields, fillableFields, massAssignable, rawSchema, provider);
        result.casts[field.name] = lodash_1.default.isNil(fieldCast.value)
            ? undefined
            : fieldCast;
        result.rules[field.name] = fieldRules;
        for (const fieldImport of fieldImports) {
            imports.add(fieldImport);
        }
        return result;
    }, { casts: {}, rules: {} })
        .mapValues(castsOrRules => lodash_1.default.omitBy(castsOrRules, v => lodash_1.default.isNil(v)))
        .value();
    const castsWithMethodCall = lodash_1.default.some(lodash_1.default.values(casts), c => c.isMethodCall);
    const rulesWithMethodCall = lodash_1.default.some(lodash_1.default.values(rules), r => lodash_1.default.some(r, r2 => r2.isMethodCall));
    const propertiesPhpDocs = lodash_1.default.chain(fields)
        .reduce((object, field) => {
        const result = lodash_1.default.clone(object);
        const { phpType, imports: fieldImports, readOnly, } = (0, get_phpdoc_properties_from_field_1.default)(field, enums, guardedFields, fillableFields, massAssignable);
        result[field.name] = { value: phpType, readOnly };
        for (const fieldImport of fieldImports) {
            imports.add(fieldImport);
        }
        return result;
    }, {})
        .omitBy(v => lodash_1.default.isNil(v.value))
        .value();
    const fieldNames = lodash_1.default.chain(fields)
        .map(f => `"${f.name}"`)
        .join(', ')
        .value();
    if (hasMany.length > 0 || belongsToMany.length > 0) {
        imports.add('\\Illuminate\\Database\\Eloquent\\Collection');
    }
    return (0, prettier_1.prettify)(`<?php
    namespace ${namespace};

    use ${extendsClass};

    ${lodash_1.default.chain([...imports])
        .map(importFcqn => `use ${importFcqn};`)
        .join('\n')
        .value()}

    /**
     * ${(0, get_model_classname_1.default)(model, prefix)} Model
     *
     * @mixin Builder
     *
     * @method static Builder|static query()
     * @method static static make(array $attributes = [])
     * @method static static create(array $attributes = [])
     * @method static static forceCreate(array $attributes)
     * @method static firstOrNew(array $attributes = [], array $values = [])
     * @method static firstOrFail($columns = ['*'])
     * @method static firstOrCreate(array $attributes, array $values = [])
     * @method static firstOr($columns = ['*'], Closure $callback = null)
     * @method static firstWhere($column, $operator = null, $value = null, $boolean = 'and')
     * @method static updateOrCreate(array $attributes, array $values = [])
     * @method null|static first($columns = ['*'])
     * @method static static findOrFail($id, $columns = ['*'])
     * @method static static findOrNew($id, $columns = ['*'])
     * @method static null|static find($id, $columns = ['*'])
     *
     ${lodash_1.default.chain(propertiesPhpDocs)
        .map((phpDocument, fieldName) => `* @property${phpDocument.readOnly ? '-read' : ''} ${phpDocument.value} $${fieldName}`)
        .join('\n')
        .value()}
     *
     ${lodash_1.default.chain(hasOne)
        .map(relation => `* @property-read null|${relation.className} $${relation.name}`)
        .join('\n')
        .value()}
     ${lodash_1.default.chain(belongsTo)
        .map(relation => `* @property-read ${relation.nullable ? 'null|' : ''}${relation.className} $${relation.name}`)
        .join('\n')
        .value()}
     ${lodash_1.default.chain(hasMany)
        .map(relation => `* @property-read Collection<${relation.className}>|${relation.className}[] $${relation.name}`)
        .join('\n')
        .value()}
     ${lodash_1.default.chain(belongsToMany)
        .map(relation => `* @property-read Collection<${relation.className}>|${relation.className}[] $${relation.name}`)
        .join('\n')
        .value()}
     */
    abstract class ${(0, get_model_classname_1.default)(model, prefix)} extends ${(0, get_class_from_fqcn_1.default)(extendsClass)} ${implementClasses.size > 0
        ? `implements ${lodash_1.default.chain([...implementClasses])
            .map(implementClass => `${implementClass}`)
            .join(', ')
            .value()}`
        : ''} {

      ${lodash_1.default.chain([...traits])
        .map(trait => `use ${trait};`)
        .join('\n')
        .value()}

      protected $table = '${tableName}';

      ${isPivot ? `public static array $PIVOT_FIELDS = [${fieldNames}];` : ''}

      ${primaryKeyField
        ? `

        ${primaryKeyField.name !== 'id'
            ? `protected $primaryKey = '${primaryKeyField.name}';`
            : ''}

        ${!primaryKeyField.hasDefaultValue ||
            typeof primaryKeyField.default !== 'object' ||
            (0, lodash_1.isArray)(primaryKeyField.default) ||
            primaryKeyField.default.name !== 'autoincrement'
            ? 'public $incrementing = false;'
            : isPivot
                ? 'public $incrementing = true;'
                : ''}

        ${primaryKeyCast &&
            primaryKeyCast.value &&
            primaryKeyCast.value !== 'integer'
            ? `protected $keyType = '${primaryKeyCast.value}';`
            : ''}
      `
        : ''}

      ${createdAtField && updatedAtField
        ? `${createdAtField.name !== 'created_at'
            ? `const CREATED_AT = '${createdAtField.name}';`
            : ''}
            ${updatedAtField.name !== 'updated_at'
            ? `const UPDATED_AT = '${updatedAtField.name}';`
            : ''}`
        : 'public $timestamps = false;'}

      ${deletedAtField && deletedAtField.name !== 'deleted_at'
        ? `const DELETED_AT = '${deletedAtField.name}';`
        : ''}

      ${defaultsWithMethodCall
        ? `protected $attributes;`
        : !lodash_1.default.isEmpty(defaults)
            ? `protected $attributes = [
              ${lodash_1.default.chain(defaults)
                .map((fieldDefault, fieldName) => `'${fieldName}' => ${lodash_1.default.isString(fieldDefault.value)
                ? `'${fieldDefault.value}'`
                : fieldDefault.value.toString()}`)
                .join(',\n')
                .value()}
            ];`
            : ''}

      ${!lodash_1.default.isEmpty(fillableFields)
        ? `protected $fillable = [
              ${lodash_1.default.chain(fillableFields)
            .map(f => `'${f.name}'`)
            .join(',\n')
            .value()}
            ];`
        : ''}

      ${massAssignable ? 'protected $guarded = [];' : ''}

      ${!lodash_1.default.isEmpty(guardedFields)
        ? `protected $guarded = [
              ${lodash_1.default.chain(guardedFields)
            .map(f => `'${f.name}'`)
            .join(',\n')
            .value()}
            ];`
        : ''}

      ${!lodash_1.default.isEmpty(hiddenFields)
        ? `protected $hidden = [
              ${lodash_1.default.chain(hiddenFields)
            .map(f => `'${f.name}'`)
            .join(',\n')
            .value()}
            ];`
        : ''}

      ${!lodash_1.default.isEmpty(visibleFields)
        ? `protected $visible = [
              ${lodash_1.default.chain(visibleFields)
            .map(f => `'${f.name}'`)
            .join(',\n')
            .value()}
            ];`
        : ''}

      ${!lodash_1.default.isEmpty(touchingFields)
        ? `protected $touches = [
              ${lodash_1.default.chain(touchingFields)
            .map(f => `'${f.name}'`)
            .join(',\n')
            .value()}
            ];`
        : ''}

      ${!lodash_1.default.isEmpty(eagerLoadedFields)
        ? `protected $with = [
              ${lodash_1.default.chain(eagerLoadedFields)
            .map(f => `'${f.name}'`)
            .join(',\n')
            .value()}
            ];`
        : ''}

      ${rulesWithMethodCall
        ? `protected array $rules;`
        : !lodash_1.default.isEmpty(rules)
            ? `protected array $rules = [
              ${lodash_1.default.chain(rules)
                .map((fieldRules, fieldName) => `'${fieldName}' => [${lodash_1.default.chain(fieldRules)
                .map(rule => `'${rule.value}'`)
                .join(',\n')
                .value()}]`)
                .join(',\n')
                .value()}
            ];`
            : ''}

      ${castsWithMethodCall
        ? 'protected $casts;'
        : !lodash_1.default.isEmpty(casts)
            ? `protected $casts = [
              ${lodash_1.default.chain(casts)
                .map((cast, fieldName) => `'${fieldName}' => '${cast.value}'`)
                .join(',\n')
                .value()}
            ];`
            : ''}

      ${defaultsWithMethodCall || rulesWithMethodCall || castsWithMethodCall
        ? `public function __construct(array $attributes = [])
             {
                ${defaultsWithMethodCall
            ? `$this->attributes = [
                        ${lodash_1.default.chain(defaults)
                .map((fieldDefault, fieldName) => `'${fieldName}' => ${lodash_1.default.isString(fieldDefault.value)
                ? fieldDefault.isMethodCall
                    ? fieldDefault.value
                    : `'${fieldDefault.value}'`
                : fieldDefault.value.toString()}`)
                .join(',\n')
                .value()},
                          ...($this->attributes ?? [])
                      ];`
            : ''}
                ${rulesWithMethodCall
            ? `$this->rules = [
                         ${lodash_1.default.chain(rules)
                .map((fieldRules, fieldName) => `'${fieldName}' => [${lodash_1.default.chain(fieldRules)
                .map(rule => rule.isMethodCall
                ? rule.value
                : `'${rule.value}'`)
                .join(',\n')
                .value()}]`)
                .join(',\n')
                .value()},
                          ...($this->rules ?? [])
                      ];`
            : ''}
                ${castsWithMethodCall
            ? `$this->casts = [
                        ${lodash_1.default.chain(casts)
                .map((cast, fieldName) => `'${fieldName}' => ${cast.isMethodCall
                ? cast.value
                : `'${cast.value}'`}`)
                .join(',\n')
                .value()},
                          ...($this->casts ?? [])
                      ];`
            : ''}
                parent::__construct($attributes);
             }`
        : ''}

      ${!lodash_1.default.isEmpty(hasOne)
        ? lodash_1.default.chain(hasOne)
            .map(relation => `public function ${relation.name}() {
                    return $this->hasOne(
                      ${(0, get_php_arguments_with_defaults_1.default)([
            `${relation.className}::class`,
            relation.foreignKey
                ? `'${relation.foreignKey}'`
                : undefined,
            relation.localKey
                ? `'${relation.localKey}'`
                : undefined,
        ], 'null')}
                    );
                  }`)
            .join('\n')
            .value()
        : ''}

      ${!lodash_1.default.isEmpty(belongsTo)
        ? lodash_1.default.chain(belongsTo)
            .map(relation => `public function ${relation.name}() {
                    return $this->belongsTo(
                      ${(0, get_php_arguments_with_defaults_1.default)([
            `${relation.className}::class`,
            relation.foreignKey
                ? `'${relation.foreignKey}'`
                : undefined,
            relation.ownerKey
                ? `'${relation.ownerKey}'`
                : undefined,
        ], 'null')}
                    );
                  }`)
            .join('\n')
            .value()
        : ''}

      ${!lodash_1.default.isEmpty(hasMany)
        ? lodash_1.default.chain(hasMany)
            .map(relation => `public function ${relation.name}() {
                    return $this->hasMany(
                      ${(0, get_php_arguments_with_defaults_1.default)([
            `${relation.className}::class`,
            relation.foreignKey
                ? `'${relation.foreignKey}'`
                : undefined,
            relation.localKey
                ? `'${relation.localKey}'`
                : undefined,
        ], 'null')}
                    );
                  }`)
            .join('\n')
            .value()
        : ''}

      ${!lodash_1.default.isEmpty(belongsToMany)
        ? lodash_1.default.chain(belongsToMany)
            .map(relation => `public function ${relation.name}() {
                    return $this->belongsToMany(
                      ${(0, get_php_arguments_with_defaults_1.default)([
            `${relation.className}::class`,
            relation.pivotTable
                ? `'${relation.pivotTable}'`
                : undefined,
            relation.foreignPivotKey
                ? `'${relation.foreignPivotKey}'`
                : undefined,
            relation.relatedPivotKey
                ? `'${relation.relatedPivotKey}'`
                : undefined,
            relation.parentKey
                ? `'${relation.parentKey}'`
                : undefined,
            relation.relatedKey
                ? `'${relation.relatedKey}'`
                : undefined,
        ], 'null')}
                    )${relation.using
            ? `->using(${relation.using}::class)->withPivot(${relation.using}::$PIVOT_FIELDS)`
            : ''};
                  }`)
            .join('\n')
            .value()
        : ''}
    }
  `);
};
exports.default = generatePrismaModel;
//# sourceMappingURL=generator.js.map