"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const promises_1 = require("node:fs/promises");
const node_os_1 = require("node:os");
const node_path_1 = require("node:path");
const createTemporaryFile = async (data = '', filename = 'temp_file') => {
    const temporaryPath = await (0, promises_1.mkdtemp)((0, node_path_1.join)((0, node_os_1.tmpdir)(), 'prisma-laravel-generator-'));
    const filePath = (0, node_path_1.join)(temporaryPath, filename);
    await (0, promises_1.writeFile)(filePath, data, 'utf8');
    return filePath;
};
exports.default = createTemporaryFile;
//# sourceMappingURL=create-temporary-file.js.map