"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const model_not_found_error_1 = __importDefault(require("../errors/model-not-found-error"));
const getModelByName = (name, models) => {
    const model = (0, lodash_1.find)(models, m => m.name === name);
    if (!model) {
        throw new model_not_found_error_1.default();
    }
    return model;
};
exports.default = getModelByName;
//# sourceMappingURL=get-model-by-name.js.map