"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const get_from_documentation_1 = __importDefault(require("../utils/get-from-documentation"));
const multiple_inheritance_error_1 = __importDefault(require("../errors/multiple-inheritance-error"));
const getModelExtend = (model) => {
    const extend = (0, get_from_documentation_1.default)(/^extends:.*/gi, model.documentation);
    const classes = (0, lodash_1.map)(extend, t => (0, lodash_1.replace)(t, /^extends:/gi, ''));
    if (classes.length > 1) {
        throw new multiple_inheritance_error_1.default();
    }
    return (0, lodash_1.last)(classes);
};
exports.default = getModelExtend;
//# sourceMappingURL=get-model-extend.js.map