"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const get_from_documentation_1 = __importDefault(require("../utils/get-from-documentation"));
const too_many_paths_error_1 = __importDefault(require("../errors/too-many-paths-error"));
const getModelPath = (model) => {
    const documentation = (0, get_from_documentation_1.default)(/^path:.*/gi, model.documentation);
    const paths = (0, lodash_1.map)(documentation, d => (0, lodash_1.replace)(d, /^path:/gi, ''));
    if (paths.length > 1) {
        throw new too_many_paths_error_1.default();
    }
    return (0, lodash_1.last)(paths);
};
exports.default = getModelPath;
//# sourceMappingURL=get-model-path.js.map