"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importDefault(require("lodash"));
const getPhpArgumentsWithDefaults = (conditionalArguments, defaults) => {
    if (lodash_1.default.isArray(defaults) && defaults.length !== conditionalArguments.length) {
        throw new Error('If defaults are provided as array, there should be exactly one default value defined for each conditional argument (the two arrays passed as argument must have the same length).');
    }
    let toBeRemoved = 0;
    const resultingArguments = [];
    for (const [index, conditionalArgument] of conditionalArguments.entries()) {
        if (lodash_1.default.isEmpty(conditionalArgument)) {
            resultingArguments.push(lodash_1.default.isArray(defaults) ? defaults[index] : defaults);
            toBeRemoved += 1;
        }
        else {
            resultingArguments.push(conditionalArgument);
            toBeRemoved = 0;
        }
    }
    return lodash_1.default.chain(resultingArguments)
        .slice(0, toBeRemoved > 0 ? -toBeRemoved : undefined)
        .join(', ')
        .value();
};
exports.default = getPhpArgumentsWithDefaults;
//# sourceMappingURL=get-php-arguments-with-defaults.js.map