"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importDefault(require("lodash"));
const find_on_documentation_1 = __importDefault(require("../utils/find-on-documentation"));
const is_field_updated_timestamp_1 = __importDefault(require("./is-field-updated-timestamp"));
const is_field_created_timestamp_1 = __importDefault(require("./is-field-created-timestamp"));
const is_field_deleted_timestamp_1 = __importDefault(require("./is-field-deleted-timestamp"));
const isFieldReadOnly = (field, guardedFields, fillableFields, massAssignable) => (0, find_on_documentation_1.default)('read-only', field.documentation) ||
    (0, is_field_created_timestamp_1.default)(field) ||
    (0, is_field_updated_timestamp_1.default)(field) ||
    (0, is_field_deleted_timestamp_1.default)(field) ||
    (field.isId &&
        !massAssignable &&
        ((lodash_1.default.isEmpty(guardedFields) && lodash_1.default.isEmpty(fillableFields)) ||
            (lodash_1.default.isEmpty(guardedFields) && !lodash_1.default.includes(fillableFields, field)) ||
            lodash_1.default.includes(guardedFields, field)));
exports.default = isFieldReadOnly;
//# sourceMappingURL=is-field-read-only.js.map