"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importStar(require("lodash"));
const cuid_not_supported_error_1 = __importDefault(require("../errors/cuid-not-supported-error"));
const is_field_enum_1 = __importDefault(require("../helpers/is-field-enum"));
const get_enum_fqcn_1 = __importDefault(require("../helpers/get-enum-fqcn"));
const getDefaultFromField = (field, enums, provider) => {
    let defaultValue;
    let isMethodCall = false;
    const imports = new Set();
    const fieldDefault = field.default;
    if ((0, lodash_1.isNil)(fieldDefault)) {
        defaultValue = undefined;
    }
    else if (!(0, lodash_1.isObject)(fieldDefault)) {
        const enumInfo = (0, is_field_enum_1.default)(field, enums);
        if (enumInfo && lodash_1.default.some(enumInfo.values, v => v.name === fieldDefault)) {
            const { fqcn } = (0, get_enum_fqcn_1.default)(enumInfo);
            imports.add(fqcn);
            defaultValue = `${enumInfo.name}::${fieldDefault.toString()}`;
            isMethodCall = true;
        }
        else {
            defaultValue = fieldDefault;
        }
    }
    else if ((0, lodash_1.isArray)(fieldDefault)) {
        const enumInfo = (0, is_field_enum_1.default)(field, enums);
        if (enumInfo &&
            lodash_1.default.every(fieldDefault, v => lodash_1.default.includes(lodash_1.default.map(enumInfo.values, enumValue => enumValue.name), v))) {
            const { fqcn } = (0, get_enum_fqcn_1.default)(enumInfo);
            imports.add(fqcn);
            defaultValue = `[${lodash_1.default.chain(fieldDefault)
                .map(v => `${enumInfo.name}::${v.toString()}`)
                .join(', ')
                .value()}]`;
            isMethodCall = true;
        }
        else {
            defaultValue = `[${lodash_1.default.chain(fieldDefault)
                .map(v => ((0, lodash_1.isString)(v) ? `'${v}'` : v.toString()))
                .join(', ')
                .value()}]`;
            isMethodCall = true;
        }
    }
    else {
        switch (fieldDefault.name) {
            case 'uuid':
                imports.add('Illuminate\\Support\\Str');
                defaultValue = 'Str::orderedUuid()';
                isMethodCall = true;
                break;
            case 'cuid':
                throw new cuid_not_supported_error_1.default();
            case 'now':
                if (provider === 'mongodb') {
                    imports.add(`Illuminate\\Support\\Carbon`);
                    defaultValue = 'Carbon::now()';
                    isMethodCall = true;
                }
                else {
                    defaultValue = undefined;
                }
                break;
            default:
                defaultValue = undefined;
                break;
        }
    }
    return { defaultValue, isMethodCall, imports };
};
exports.default = getDefaultFromField;
//# sourceMappingURL=get-default-from-field.js.map