"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const modelRegexp = (modelName) => new RegExp(`(\\s+|^)model\\s+${modelName}\\s*\\{([^}]*)}`, 'gm');
const commentsMatcher = /(?<!\/)\/\/[^\n/]+/gm;
const modelAttributesMatcher = /@@\S+/gm;
const getModelLines = (modelName, rawContent) => {
    const modelSection = modelRegexp(modelName).exec(rawContent);
    if (!modelSection || modelSection.length < 2) {
        return false;
    }
    return `${modelSection[2]
        .trim()
        .replaceAll(modelAttributesMatcher, '')
        .replaceAll(commentsMatcher, '')}`;
};
exports.default = getModelLines;
//# sourceMappingURL=get-model-lines.js.map