"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const ucfirst_1 = __importDefault(require("./ucfirst"));
const ucwords_1 = __importDefault(require("./ucwords"));
const matchCase = (value, comparison) => {
    const functions = [lodash_1.toLower, lodash_1.toUpper, ucfirst_1.default, ucwords_1.default];
    for (const f of functions) {
        if (f(comparison) === comparison) {
            return f(value);
        }
    }
    return value;
};
exports.default = matchCase;
//# sourceMappingURL=match-case.js.map